#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);

#############################################################
# Set program parameters here                               #
#############################################################

# List of IP addresses to ignore, add your own IP to the list
@ignore = ("127.0.0.1");

# Time (in minutes) to show the user as online after the last request
$keep_online_time = 15;

# Time (in minutes) to save the user's IP after the last request. The counter is only increased for unknown IPs.
$keep_in_log_time = 60;

# Set to 0 if your server's operating system doesn't implement flock() (for example Windows 95/98/ME)
$use_flock = 1;

# Directory of the counter templates (counter_xxx.html)
$templ_dir = ".";

# Directory of the counter data (log.txt and count.txt)
$data_dir = "Data";

#############################################################
# Program starts here                                       #
# GTCounter 1.1 by Wladimir Palant (http://www.gtchat.de/)  #
#############################################################

$LOCK_EX = 2;
$LOCK_UN = 8;
$current_time = time;

open(LOG, "+>>$data_dir/log.txt");
flock(LOG,$LOCK_EX) if ($use_flock);
seek(LOG,0,0);

@entries = <LOG>;

seek(LOG,0,0);
truncate(LOG,0);

$add=1;
$online=1;
$ignore=0;
foreach (@ignore)
{
	if ($ENV{REMOTE_ADDR} eq $_)
	{
		$add=0;
		$online=0;
		$ignore=1;
	}
}

print LOG "$ENV{REMOTE_ADDR}|$current_time\n" if (!$ignore);
foreach $curentry (@entries)
{
	$curentry =~ s/[\n\r]//g;
	($ip, $time) = split(/\|/, $curentry);
	if ($current_time - $time <= $keep_in_log_time*60 && $ip ne $ENV{REMOTE_ADDR})
	{
		print LOG "$curentry\n";
	}
	if ($current_time - $time <= $keep_online_time*60 && $ip ne $ENV{REMOTE_ADDR})
	{
		$online++;
	}
	if ($current_time - $time <= $keep_in_log_time*60 && $ip eq $ENV{REMOTE_ADDR})
	{
		$add=0;
	}
}
flock(LOG,$LOCK_UN) if ($use_flock);
close(LOG);

open(COUNT, "+>>$data_dir/count.txt");
flock(COUNT,$LOCK_EX) if ($use_flock);
seek(COUNT,0,0);

$count = <COUNT>;
if ($add != 0)
{
	$count++;
	seek(COUNT,0,0);
	truncate(COUNT,0);
	print COUNT $count;
}

flock(COUNT,$LOCK_UN) if ($use_flock);
close(COUNT);

if (!defined($no_output))
{
	print "Content-type: text/html\n";
	print "Pragma: no-cache\n";
	print "Expires: now\n\n";
	
	$ENV{QUERY_STRING} =~ s/\W//g;
	if ($ENV{QUERY_STRING} eq "")
	{
		open(FILE,"$templ_dir/counter.html");
	}
	else
	{
		open(FILE,"$templ_dir/counter_$ENV{QUERY_STRING}.html");
	}
	
	foreach (<FILE>)
	{
		$_ =~ s/{ONLINE}/$online/g;
		$_ =~ s/{COUNT}/$count/g;
		print "$_";
	}
	close(FILE);
	exit;
}

1;
